﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class levelGenerate : MonoBehaviour {
	public Camera MainCamera;
	public GameObject player;
	public GameObject skeleton;
	public GameObject dungeon1;
	public GameObject dungeon2;
	public GameObject dungeon3;
	public GameObject key;
	public GameObject hpBKG; //The health bar background
	public GameObject hpBar; //The health bar

	int dun3Pos = 0; //1 for top, 2 for left side, 3 for bottom. used to rotate skeleton waypoints

	string keySpawn; //the spawn location of the key

	// Use this for initialization
	void Start () {
		player.name = "player";
		Instantiate (player, new Vector3 (0, -5, 1), Quaternion.identity);
		dungeonSpawner ();
		MainCamera.name = "MainCamera";
		Instantiate(MainCamera, new Vector3(0,-5,-10), Quaternion.identity);
		hpBKG.name = "hpBKG";
		hpBar.name = "hpBar";
		Instantiate(hpBKG, new Vector3(0,0,-10), Quaternion.identity);
		Instantiate(hpBar, new Vector3(0,0,-10), Quaternion.identity);

		Vector3 keyLoc = universalFunctions.universalObjectSearch (keySpawn).transform.position;
		key.name = "key";
		Instantiate (key, keyLoc, Quaternion.identity);
		//set the dungeon position for the skeletons
		universalFunctions.universalObjectSearch ("skeleton (0)").GetComponent<skeleton> ().dunPos = dun3Pos;
		universalFunctions.universalObjectSearch ("skeleton (1)").GetComponent<skeleton> ().dunPos = dun3Pos;
		universalFunctions.universalObjectSearch ("skeleton (2)").GetComponent<skeleton> ().dunPos = dun3Pos;
		universalFunctions.universalObjectSearch ("skeleton (3)").GetComponent<skeleton> ().dunPos = dun3Pos;

		Destroy (gameObject);
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	//spawns the dungeon rooms
	void dungeonSpawner(){
		dungeon1.name = "dungeon1";
		dungeon2.name = "dungeon2";
		dungeon3.name = "dungeon3";
		//randomly order the 3 dungeon rooms
		GameObject[] gameObjects = {dungeon1,dungeon2,dungeon3};
		ShuffleArray (gameObjects);
		for (int i = 0; i < gameObjects.Length; i++) {
			switch (i){
			case 0: //north, dont rotate
				if(gameObjects [i].name.Contains ("dungeon1")){
					Instantiate (dungeon1, new Vector3 (0, 37.6f, 1), Quaternion.identity);
				}else if(gameObjects [i].name.Contains ("dungeon2")){
					Instantiate (dungeon2, new Vector3 (0, 46.9f, 1), Quaternion.identity);
				}else if (gameObjects [i].name.Contains ("dungeon3")) {
					Instantiate (dungeon3, new Vector3 (0, 56, 1), Quaternion.identity);
					dun3Pos = 1;
				}
				break;
			case 1: //west, rotate 90 degrees
				if(gameObjects [i].name.Contains ("dungeon1")){
					Instantiate (dungeon1, new Vector3 (-39, 0, 1), Quaternion.AngleAxis(90f, Vector3.forward));
				}else if(gameObjects [i].name.Contains ("dungeon2")){
					Instantiate (dungeon2, new Vector3 (-48.4f, 0, 1),  Quaternion.AngleAxis(90f, Vector3.forward));
				}else if (gameObjects [i].name.Contains ("dungeon3")) {
					Instantiate (dungeon3, new Vector3 (-57.7f, 0, 1),  Quaternion.AngleAxis(90f, Vector3.forward));
					dun3Pos = 2;
				}
				break;
			case 2: //south, rotate 180 degrees
				if(gameObjects [i].name.Contains ("dungeon1")){
					Instantiate (dungeon1, new Vector3 (0, -37.6f, 1), Quaternion.AngleAxis(180f, Vector3.forward));
				}else if(gameObjects [i].name.Contains ("dungeon2")){
					Instantiate (dungeon2, new Vector3 (0, -46.9f, 1), Quaternion.AngleAxis(180f, Vector3.forward));
				}else if (gameObjects [i].name.Contains ("dungeon3")) {
					Instantiate (dungeon3, new Vector3 (0, -56, 1), Quaternion.AngleAxis(180f, Vector3.forward));
					dun3Pos = 3;
				}
				break;
			}
		}
		//randomly assign the key to one of the 3 rooms
		int loc = Random.Range(1,3);
		switch (loc) {
		case 1:
			keySpawn = "keySpawner1";
			break;
		case 2:
			keySpawn = "keySpawner2";
			break;
		case 3:
			keySpawn = "keySpawner3";
			break;
		}
	}

	void ShuffleArray<T>(T[] array){
		int n = array.Length;
		for (int i = 0; i < n; i++) {
			int r = i + Random.Range (0, n - i);
			//swap item into spot
			T t = array [r];
			array [r] = array [i];
			array [i] = t;
		}
	}
}
