﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class playerControl : MonoBehaviour {
	public GameObject sword;
	public GameObject wepIdle;
	public GameObject deathAnim;
	public GameObject gameOver;
	public GameObject hackUI;
	int frameCounter =0;
	public float speed = 6f;
	public int facing = 1;//1=right,2=left,3=up,4=down
	private Vector3 moveDirection = Vector3.zero;
	public int health = 100;
	public bool hasKey = false;
	bool swing = false;
	public bool hacking = false;
	bool knockback = false;
	bool canBeDamaged = true;
	LineRenderer line;
	public Material lineMaterial;
	CharacterController controller;

	AudioSource audio;
	public AudioClip takeDamage;
	public AudioClip hitEnemy;
	public AudioClip hitBlock;
	public AudioClip keyGet;
	public AudioClip keyUse;
	public AudioClip heal;
	// Use this for initialization
	void Start () {
		audio = gameObject.GetComponent<AudioSource> ();
		controller = gameObject.GetComponent<CharacterController> ();
		wepIdle.name = "wepIdle";
		Instantiate (wepIdle, gameObject.transform.position + new Vector3 (2, 0, 0), Quaternion.identity);

		line = gameObject.GetComponent<LineRenderer> ();
		line.material = lineMaterial;
		line.SetPosition(0, new Vector3(1000,1000,0));
		line.SetPosition(1, new Vector3(1000,1000,0));
		line.SetWidth(0.25f, 0.5f);
		line.SetVertexCount(2);
	}
	
	// Update is called once per frame
	void Update () {
		//keeps the player from ascending up a layer
		transform.position = new Vector3(transform.position.x, transform.position.y, 1);
		//kill the player if their health hits 0
		if (health <= 0) {
			Instantiate(deathAnim, gameObject.transform.position, Quaternion.identity);
			Instantiate (gameOver, gameObject.transform.position, Quaternion.identity);
			Destroy (gameObject);
		}
		//check to see if the sword is out
		GameObject swordTest = universalFunctions.universalObjectSearch("sword");
		if (swordTest == null) {
			GameObject idleWep = universalFunctions.universalObjectSearch("wepIdle");
			if (idleWep == null) {
				wepIdle.name = "wepIdle";
				Instantiate (wepIdle, gameObject.transform.position, Quaternion.identity);
			}
			swing = false;
		}
			//set facing direction
			float horz = Input.GetAxis ("Horizontal");
			float vert = Input.GetAxis ("Vertical");
			if (Mathf.Abs (horz) > Mathf.Abs (vert)) {
				if (horz > 0) {
					facing = 1;
				} else {
					facing = 2;
				}
			} else if (Mathf.Abs (horz) < Mathf.Abs (vert)) {
				if (vert > 0) {
					facing = 3;
				} else {
					facing = 4;
				}
			}
			moveDirection = new Vector3 (Input.GetAxis ("Horizontal"), Input.GetAxis ("Vertical"), 0);
			moveDirection = transform.TransformDirection (moveDirection);
			moveDirection *= speed;
			controller.Move (moveDirection * Time.deltaTime);

		//sword attack
		if (Input.GetKeyDown ("z") && swing == false) {
			sword.name = "sword";
			GameObject idleWep = universalFunctions.universalObjectSearch("wepIdle");
			Destroy (idleWep);
			Instantiate (sword, gameObject.transform.position, Quaternion.identity);
			audio.clip= hitEnemy;
			audio.Play ();
			swing = true;
		}
		//hacking gun
		if (Input.GetKeyDown ("x") && hacking == false) {
			Vector3 dir = new Vector3(0,0,0);
			switch (facing){
			case 1:
				dir = new Vector3 (1, 0, 0);
				break;
			case 2:
				dir = new Vector3 (-1, 0, 0);
				break;
			case 3:
				dir = new Vector3 (0, 1, 0);
				break;
			case 4:
				dir = new Vector3 (0, -1, 0);
				break;
			}
			Ray laser = new Ray (gameObject.transform.position, dir);
			Vector3 lineEnd = gameObject.transform.position;
			hackUI.name="hackUI";
			RaycastHit hit;
			if (Physics.Raycast (laser, out hit)) {
				line.SetPosition (0, gameObject.transform.position);
				line.SetPosition (1, hit.point + hit.normal);
				line.enabled = true;
				if (hit.collider.gameObject.name.Contains("skeleton") && hit.collider.gameObject.GetComponent<skeleton>().isHacked == false) {
					audio.clip = hitEnemy;
					audio.Play ();
					hacking = true;
					hackUI.GetComponent<hackingScript> ().hackedObject = hit.collider.gameObject;
					Instantiate (hackUI, gameObject.transform.position, Quaternion.identity);
					//pop open hacking window
					//hacking = false;
				}

				else if (hit.collider.gameObject.name.Contains("ghosts") && hit.collider.gameObject.GetComponent<ghost>().isHacked == false) {
					audio.clip = hitEnemy;
					audio.Play ();
					hacking = true;
					hackUI.GetComponent<hackingScript> ().hackedObject = hit.collider.gameObject;
					Instantiate (hackUI, gameObject.transform.position, Quaternion.identity);
					//pop open hacking window
					//hacking = false;
				}

				else if (hit.collider.gameObject.name.Contains("moveableBlock") && hit.collider.gameObject.GetComponent<moveBlock>().isHacked == false) {
					audio.clip = hitEnemy;
					audio.Play ();
					hacking = true;
					hackUI.GetComponent<hackingScript> ().hackedObject = hit.collider.gameObject;
					Instantiate (hackUI, gameObject.transform.position, Quaternion.identity);
					//pop open hacking window
					//hacking = false;
				}
			}
		}
		if (Input.GetKeyUp ("x")) {
			line.enabled = false;
		}
		if (line.enabled == true) {
			frameCounter++;
		}
		if (frameCounter > 15) {
			line.enabled = false;
			frameCounter = 0;
		}
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.name.Contains ("heart")) {
			audio.clip = heal;
			audio.Play ();
			health = 100;
		}
		if (col.gameObject.name.Contains ("key")) {
			hasKey = true;
			audio.clip = keyGet;
			audio.Play ();
			Destroy (col.gameObject);
		}
		if (col.gameObject.name.Contains ("lockedDoor")) {
			if (hasKey == true) {
				print ("key used");
				audio.clip = keyUse;
				audio.Play ();
				Destroy (col.gameObject);
			} else {
				print ("You need the key");
			}
		}
		if ((col.gameObject.name.Contains("skeleton") && canBeDamaged == true && hacking == false) || (col.gameObject.name.Contains("ghosts") && canBeDamaged == true && hacking == false)) {
			canBeDamaged = false;
			float force = 3f; //force applied when knocking back
			Vector3 dir = new Vector3(0,0,0); //general direction holder
			//set direction
			switch (facing) {
			case 1:
				dir = new Vector3 (-1, 0, 0);
				break;
			case 2:
				dir = new Vector3 (1, 0, 0);
				break;
			case 3:
				dir = new Vector3 (0, -1, 0);
				break;
			case 4:
				dir = new Vector3 (0, 1, 0);
				break;
			}
			// add force in the direction of dir and multiply it by force 
			// This will knock back the object
			controller.Move (dir * force);
			audio.clip = takeDamage;
			audio.Play ();
			health -= 5;
			//TD- play damage animation
		}
	}

	void OnTriggerExit(Collider col){
		if (col.gameObject.name.Contains ("skeleton") && canBeDamaged == false) {
			canBeDamaged = true;
		}
	}
}
