﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class skeleton : MonoBehaviour {
	GameObject player;
	public GameObject deathAnim;
	public int health = 100;
	private Vector3 moveDirection = Vector3.zero;
	bool canBeDamaged = true;
	public bool isHacked = false;

	float distance; //distance between player and enemy
	public float sightRange = 10f;//how far the skeleton can see
	float cSpeed = 0.05f; //chase speed of enemy
	public Vector3[] waypoint;        // The amount of Waypoint you want
	public float patrolSpeed = 6f;       // The walking speed between Waypoints
	public bool  loop = true;       // Do you want to keep repeating the Waypoints
	public float pauseDuration = 0;   // How long to pause at a Waypoint
	public int dunPos =0; //the position of dungeon 3

	private float curTime;
	private int currentWaypoint = 0;
	CharacterController controller;
	bool walking = false;

	AudioSource audio;
	public AudioClip invulnerable;
	public AudioClip damage;
	// Use this for initialization
	void Start () {
		audio = gameObject.GetComponent<AudioSource> ();
		//waypoints run patrol path, this is 5x5
		waypoint = new Vector3[4];
		Vector3 temp = gameObject.transform.position;
		if (dunPos == 1) {
			waypoint [0] = (temp + new Vector3 (5, 0, 0));
			waypoint [1] = (temp + new Vector3 (5, 5, 0));
			waypoint [2] = (temp + new Vector3 (0, 5, 0));
			waypoint [3] = (temp);
		} else if (dunPos == 2) {
			waypoint [0] = (temp + new Vector3 (0, 5, 0));
			waypoint [1] = (temp + new Vector3 (-5f, 5, 0));
			waypoint [2] = (temp + new Vector3 (-5f, -1f, 0));
			waypoint [3] = (temp);
		} else if (dunPos == 3) {
			waypoint [0] = (temp + new Vector3 (-5f, 0, 0));
			waypoint [1] = (temp + new Vector3 (-5f, -5f, 0));
			waypoint [2] = (temp + new Vector3 (0, -5f, 0));
			waypoint [3] = (temp);
		}
		controller = gameObject.GetComponent<CharacterController> ();
		player = universalFunctions.universalObjectSearch ("player");
		distance = Vector3.Distance(player.transform.position, gameObject.transform.position);
	}
	
	// Update is called once per frame
	void Update () {
		if (health <= 0) {
			//TD-play death animation
			Instantiate(deathAnim, gameObject.transform.position, Quaternion.identity);

			Destroy (gameObject);
		}
			
		//if the player is within 10 units, chase them
		distance = Vector3.Distance(player.transform.position, gameObject.transform.position);
		if (distance <= sightRange) {
			controller.Move((player.transform.position-gameObject.transform.position) * cSpeed);
		}
		//otherwise, patrol
		else if (distance > sightRange && currentWaypoint < 4) {
			patrol ();
		} else {
			if (loop) {
				currentWaypoint = 0;
			}
		}
	}

	void OnTriggerEnter(Collider col){
		if (col.gameObject.name.Contains("sword") && canBeDamaged == true && isHacked == true) {
			canBeDamaged = false;
			float force = 1.25f; //force applied when knocking back
			Vector3 dir = new Vector3(0,0,0); //general direction holderreak;
			// add force in the direction of dir and multiply it by force 
			// This will knock back the object
			dir = -1*(player.transform.position-gameObject.transform.position);
			controller.Move (dir * force);
			audio.clip = damage;
			audio.Play ();
			health -= 25;
			//TD-play damage animation
		} else if (col.gameObject.name.Contains ("sword") && isHacked == false) {
			audio.clip = invulnerable;
			audio.Play ();
		}
	}

	void OnTriggerExit(Collider col){
		if (col.gameObject.name.Contains ("sword")) {
			canBeDamaged = true;
		}
	}

	//enemy patrols in a square
	void  patrol (){
		Vector3 target = waypoint[currentWaypoint];
		Vector3 moveDirection = target - transform.position;

		if(moveDirection.magnitude < 0.5f){
			if (curTime == 0)
				curTime = Time.time; // Pause over the Waypoint
			if ((Time.time - curTime) >= pauseDuration){
				currentWaypoint++;
				curTime = 0;
			}
		}else{        
			//TD-change animation to face new direction
			controller.Move(moveDirection.normalized * patrolSpeed * Time.deltaTime);
		}  
	}
}
